/* server -- tworzy trzy procesy potomne */
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/select.h>
#include <stdio.h>

#include "err.h"

#define MSGSIZE 6

char *msg1 = "hello";
char *msg2 = "bye!!";

void parent(int [3][2]);
int child(int [2]);


int main()

{ 
  int pip[3][2];
  int i;

  /* trzy potoki i troje potomkw */
  for(i = 0; i < 3; i++ )
    {  if (pipe(pip[i]) == -1) fatal("pipe call");

	   switch(fork()) {
           case -1:
	     fatal("fork call");
           case  0:
             child(pip[i]);
	   }
    } /* for */

  parent(pip);

  exit(0);
} 

/* rodzic nasuchuje na trzech potokach */
void parent(int p[3][2])
{
  char buf[MSGSIZE], ch;
  fd_set set, master;
  int i;
 
  /* zamykam niepotrzebne deskryptory  */ 	   
  for (i = 0; i < 3; i++)
    close(p[i][1]);

  /* ustawiam maski dla select         */

  FD_ZERO(&master);
  FD_SET(0, &master);

  for (i = 0; i< 3; i++)
    FD_SET(p[i][0], &master);

  /* select wywoane bez czasu, powinno si blokowa a
     do wystpienia zdarzenia */

  while(set = master, select(p[2][0]+1, &set, NULL, NULL, NULL) > 0)

    { /* moe cos na fd = 0 ? */

      if(FD_ISSET(0, &set))
      { 
        printf("Z klawiatury ...");
        read(0, &ch, 1);
        printf("%c\n", ch);
      }
      
      for( i = 0; i < 3; i++)
	{
        
	 if(FD_ISSET(p[i][0], &set))
	 {
           if(read(p[i][0], buf, MSGSIZE) > 0)
	     {  
               printf("Message od dziecka%d\n", i);
               printf("MSG=%s\n", buf);
	     }
	 }
	}
      
      /* koniec, jeli nie ma ju dzieci */

      if (waitpid(-1, NULL, WNOHANG) == -1) return;
    }
}

int child(int p[2])
{
  int count;

  close(p[0]);
  
  for (count = 0; count <2; count++)
    {
      write(p[1], msg1, MSGSIZE);
      /* troch poczekaj */
      sleep(getpid() %4 );
    }

  /* kocowy komunikat */
  write(p[1], msg2, MSGSIZE);
  exit(0);
}
 
	 
	    
	       



